/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_AMDGPUEMULATEATOMICSPASS
#define GEN_PASS_DECL_OPTIMIZESHAREDMEMORY
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// AmdgpuEmulateAtomicsPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_AMDGPUEMULATEATOMICSPASS
struct AmdgpuEmulateAtomicsPassOptions {
  std::string chipset = "gfx000";
};
std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass();
std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass(const AmdgpuEmulateAtomicsPassOptions &options);
#undef GEN_PASS_DECL_AMDGPUEMULATEATOMICSPASS
#endif // GEN_PASS_DECL_AMDGPUEMULATEATOMICSPASS
#ifdef GEN_PASS_DEF_AMDGPUEMULATEATOMICSPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass();
} // namespace impl

namespace impl {
  std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass(const AmdgpuEmulateAtomicsPassOptions &options);
} // namespace impl
namespace impl {

template <typename DerivedT>
class AmdgpuEmulateAtomicsPassBase : public ::mlir::OperationPass<> {
public:
  using Base = AmdgpuEmulateAtomicsPassBase;

  AmdgpuEmulateAtomicsPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  AmdgpuEmulateAtomicsPassBase(const AmdgpuEmulateAtomicsPassBase &other) : ::mlir::OperationPass<>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("amdgpu-emulate-atomics");
  }
  ::llvm::StringRef getArgument() const override { return "amdgpu-emulate-atomics"; }

  ::llvm::StringRef getDescription() const override { return "Emulate atomic operations on chipsets that do not support them"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AmdgpuEmulateAtomicsPass");
  }
  ::llvm::StringRef getName() const override { return "AmdgpuEmulateAtomicsPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<cf::ControlFlowDialect>();
    registry.insert<arith::ArithDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AmdgpuEmulateAtomicsPassBase<DerivedT>)

  AmdgpuEmulateAtomicsPassBase(const AmdgpuEmulateAtomicsPassOptions &options) : AmdgpuEmulateAtomicsPassBase() {
    chipset = options.chipset;
  }
protected:
  ::mlir::Pass::Option<std::string> chipset{*this, "chipset", ::llvm::cl::desc("Chipset that these operations will run on"), ::llvm::cl::init("gfx000")};
private:

  friend std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass() {
    return std::make_unique<DerivedT>();
  }

  friend std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass(const AmdgpuEmulateAtomicsPassOptions &options) {
    return std::make_unique<DerivedT>(options);
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass() {
  return impl::createAmdgpuEmulateAtomicsPass();
}

std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass(const AmdgpuEmulateAtomicsPassOptions &options) {
  return impl::createAmdgpuEmulateAtomicsPass(options);
}
#undef GEN_PASS_DEF_AMDGPUEMULATEATOMICSPASS
#endif // GEN_PASS_DEF_AMDGPUEMULATEATOMICSPASS

//===----------------------------------------------------------------------===//
// OptimizeSharedMemory
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_OPTIMIZESHAREDMEMORY
struct OptimizeSharedMemoryOptions {
  int64_t sharedMemoryLineSizeBytes = 128;
  int64_t defaultVectorSizeBits = 128;
};
std::unique_ptr<::mlir::Pass> createOptimizeSharedMemory();
std::unique_ptr<::mlir::Pass> createOptimizeSharedMemory(const OptimizeSharedMemoryOptions &options);
#undef GEN_PASS_DECL_OPTIMIZESHAREDMEMORY
#endif // GEN_PASS_DECL_OPTIMIZESHAREDMEMORY
#ifdef GEN_PASS_DEF_OPTIMIZESHAREDMEMORY

namespace impl {
  std::unique_ptr<::mlir::Pass> createOptimizeSharedMemory();
} // namespace impl

namespace impl {
  std::unique_ptr<::mlir::Pass> createOptimizeSharedMemory(const OptimizeSharedMemoryOptions &options);
} // namespace impl
namespace impl {

template <typename DerivedT>
class OptimizeSharedMemoryBase : public ::mlir::OperationPass<> {
public:
  using Base = OptimizeSharedMemoryBase;

  OptimizeSharedMemoryBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  OptimizeSharedMemoryBase(const OptimizeSharedMemoryBase &other) : ::mlir::OperationPass<>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("amdgpu-optimize-shared-memory");
  }
  ::llvm::StringRef getArgument() const override { return "amdgpu-optimize-shared-memory"; }

  ::llvm::StringRef getDescription() const override { return "Optimizes accesses to shared memory memrefs in order to reduce bank conflicts."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("OptimizeSharedMemory");
  }
  ::llvm::StringRef getName() const override { return "OptimizeSharedMemory"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<memref::MemRefDialect>();
    registry.insert<vector::VectorDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(OptimizeSharedMemoryBase<DerivedT>)

  OptimizeSharedMemoryBase(const OptimizeSharedMemoryOptions &options) : OptimizeSharedMemoryBase() {
    sharedMemoryLineSizeBytes = options.sharedMemoryLineSizeBytes;
    defaultVectorSizeBits = options.defaultVectorSizeBits;
  }
protected:
  ::mlir::Pass::Option<int64_t> sharedMemoryLineSizeBytes{*this, "shared-memory-line-size-bytes", ::llvm::cl::desc("Shared memory line size in bytes"), ::llvm::cl::init(128)};
  ::mlir::Pass::Option<int64_t> defaultVectorSizeBits{*this, "default-vector-size-bits", ::llvm::cl::desc("Default vector size in bits"), ::llvm::cl::init(128)};
private:

  friend std::unique_ptr<::mlir::Pass> createOptimizeSharedMemory() {
    return std::make_unique<DerivedT>();
  }

  friend std::unique_ptr<::mlir::Pass> createOptimizeSharedMemory(const OptimizeSharedMemoryOptions &options) {
    return std::make_unique<DerivedT>(options);
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createOptimizeSharedMemory() {
  return impl::createOptimizeSharedMemory();
}

std::unique_ptr<::mlir::Pass> createOptimizeSharedMemory(const OptimizeSharedMemoryOptions &options) {
  return impl::createOptimizeSharedMemory(options);
}
#undef GEN_PASS_DEF_OPTIMIZESHAREDMEMORY
#endif // GEN_PASS_DEF_OPTIMIZESHAREDMEMORY
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// AmdgpuEmulateAtomicsPass Registration
//===----------------------------------------------------------------------===//

inline void registerAmdgpuEmulateAtomicsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createAmdgpuEmulateAtomicsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerAmdgpuEmulateAtomicsPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createAmdgpuEmulateAtomicsPass();
  });
}

//===----------------------------------------------------------------------===//
// OptimizeSharedMemory Registration
//===----------------------------------------------------------------------===//

inline void registerOptimizeSharedMemory() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createOptimizeSharedMemory();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerOptimizeSharedMemoryPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createOptimizeSharedMemory();
  });
}

//===----------------------------------------------------------------------===//
// AMDGPU Registration
//===----------------------------------------------------------------------===//

inline void registerAMDGPUPasses() {
  registerAmdgpuEmulateAtomicsPass();
  registerOptimizeSharedMemory();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class AmdgpuEmulateAtomicsPassBase : public ::mlir::OperationPass<> {
public:
  using Base = AmdgpuEmulateAtomicsPassBase;

  AmdgpuEmulateAtomicsPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  AmdgpuEmulateAtomicsPassBase(const AmdgpuEmulateAtomicsPassBase &other) : ::mlir::OperationPass<>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("amdgpu-emulate-atomics");
  }
  ::llvm::StringRef getArgument() const override { return "amdgpu-emulate-atomics"; }

  ::llvm::StringRef getDescription() const override { return "Emulate atomic operations on chipsets that do not support them"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AmdgpuEmulateAtomicsPass");
  }
  ::llvm::StringRef getName() const override { return "AmdgpuEmulateAtomicsPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<cf::ControlFlowDialect>();
    registry.insert<arith::ArithDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AmdgpuEmulateAtomicsPassBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> chipset{*this, "chipset", ::llvm::cl::desc("Chipset that these operations will run on"), ::llvm::cl::init("gfx000")};
};

template <typename DerivedT>
class OptimizeSharedMemoryBase : public ::mlir::OperationPass<> {
public:
  using Base = OptimizeSharedMemoryBase;

  OptimizeSharedMemoryBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  OptimizeSharedMemoryBase(const OptimizeSharedMemoryBase &other) : ::mlir::OperationPass<>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("amdgpu-optimize-shared-memory");
  }
  ::llvm::StringRef getArgument() const override { return "amdgpu-optimize-shared-memory"; }

  ::llvm::StringRef getDescription() const override { return "Optimizes accesses to shared memory memrefs in order to reduce bank conflicts."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("OptimizeSharedMemory");
  }
  ::llvm::StringRef getName() const override { return "OptimizeSharedMemory"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<memref::MemRefDialect>();
    registry.insert<vector::VectorDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(OptimizeSharedMemoryBase<DerivedT>)

protected:
  ::mlir::Pass::Option<int64_t> sharedMemoryLineSizeBytes{*this, "shared-memory-line-size-bytes", ::llvm::cl::desc("Shared memory line size in bytes"), ::llvm::cl::init(128)};
  ::mlir::Pass::Option<int64_t> defaultVectorSizeBits{*this, "default-vector-size-bits", ::llvm::cl::desc("Default vector size in bits"), ::llvm::cl::init(128)};
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
